
import authenticator_client
import video_client
import configuration_client
import json
import liveview

f = open("network_settings.json","r") #load network settings into memory
settings = json.load(f)
f.close()

def main():
        print("Default camera IP is", settings['Server IP']) #get the current IP from the network settings file
        print("Press enter to connect to this IP, or enter a new IP and press enter") #press enter to connect to the IP in memory, or enter a custom IP
        ip_to_connect = input()
        if len(ip_to_connect) > 0:
                settings['Server IP'] = ip_to_connect
                f = open("network_settings.json", "w") #update network settings to reflect a custom IP
                json.dump(settings, f)
                f.close()
        keys_exchanged = authenticator_client.main() #check AES/HMAC keys have been successfully exchanged
        if keys_exchanged: #let the user know
                print("Key exchange complete.")
        else: #if keys have not been exchanged, quit the program
                print("Authentication failed. Please try again.")
                return
        while keys_exchanged: #give the user options
                print("Please select an option")
                print("1) View camera live stream")
                print("2) Download or delete saved videos")
                print("3) Change camera settings")
                print("Enter any other option to exit this program")
                option = input()
                try:
                        if option == "1": #start the live stream viewer process
                                liveview.main()
                        elif option == "2": #start the video client process
                                video_client.main()
                        elif option == "3": #start the remote configuration process
                                configuration_client.main()
                        else:
                                print("Exiting program...") #eit the program
                                break
                except KeyboardInterrupt:
                        pass
                        
if __name__ == "__main__":
        main()

